#include <bits/stdc++.h> 
using namespace std;
#define fastIO ios::sync_with_stdio(false),cin.tie(0),cout.tie(0)
const int N = 500003;
int n,Q,st[N][20],f[N][20];
int dep[N];
vector<int> v[N];
void dfs(int x,int fa){ dep[x]=dep[fa]+1;
	f[x][0]=fa;
	for(int i=1;i<=19;i++) f[x][i]=f[f[x][i-1]][i-1];
	for(int y:v[x]){
		if(y==fa) continue;
		dfs(y,x);
	}
}
int LCA(int x,int y){ if(x==y) return x;
	if(dep[x]<dep[y]) swap(x,y);
	for(int i=19;i>=0;i--){
		if(dep[f[x][i]]>=dep[y]) x=f[x][i]; 
	}
	if(x==y) return x;
	for(int i=19;i>=0;i--){
		if(f[x][i]!=f[y][i]){
			x=f[x][i]; y=f[y][i];
		}
	}
	return f[x][0];
}
int get_ans(int x,int y){
	int t=log2(y-x+1);
	return LCA(st[x][t],st[y-(1<<t)+1][t]);
}
signed main(){ freopen("query.in","r",stdin); freopen("query.out","w",stdout); fastIO;
	cin >> n;
	for(int i=1,x,y;i<n;i++){
		cin >> x >> y; st[i][0]=i;
		v[x].push_back(y); v[y].push_back(x);
	}
	dfs(1,0);
	for(int j=1;j<=19;j++){
		for(int i=1;i<=n-(1<<j)+1;i++){
			st[i][j]=LCA(st[i][j-1],st[i+(1<<(j-1))][j-1]);
		}
	}
	int l,r,x;
	cin >> Q;
	while(Q--){
		cin >> l >> r >> x;
		int ans=max(dep[get_ans(l,l+x-1)],dep[get_ans(r-x+1,r)]); int mx=-1;
		for(int i=l+x;i<=r;i++){
			if(dep[i]<=ans) mx=i;
			if(mx+x<=i){
				ans=max(ans,dep[get_ans(i-x+1,i)]);
			}
		}
		cout << ans << endl;
	}
}
